import { Getter } from '@loopback/core';
import { BelongsToAccessor } from '@loopback/repository';
import { SequelizeDataSource } from '@loopback/sequelize';
import { IAuthUserWithPermissions } from '@sourceloop/core';
import { SequelizeUserModifyCrudRepository } from '@sourceloop/core/sequelize';
import { UserLevelResource, UserTenant } from '../../models';
import { UserTenantRepository } from '../user-tenant.repository';
export declare class UserLevelResourceRepository extends SequelizeUserModifyCrudRepository<UserLevelResource, typeof UserLevelResource.prototype.id> {
    protected readonly getCurrentUser: Getter<IAuthUserWithPermissions | undefined>;
    protected userTenantRepositoryGetter: Getter<UserTenantRepository>;
    readonly userTenant: BelongsToAccessor<UserTenant, typeof UserLevelResource.prototype.id>;
    constructor(dataSource: SequelizeDataSource, getCurrentUser: Getter<IAuthUserWithPermissions | undefined>, userTenantRepositoryGetter: Getter<UserTenantRepository>);
}
